<?php
require_once(ROOTDIR."/include/class.rcon.php");
require_once(ROOTDIR."/include/database/class.BanQueries.php");
require_once(ROOTDIR."/include/database/class.ServerQueries.php");
include_once(ROOTDIR."/include/database/class.UserQueries.php");
require_once(ROOTDIR."/include/objects/class.Server.php");

// Variables
$steamId = $_POST['steamId'];
$length = $_POST['length']; // In hours
$reason = $_POST['reason']; // Reason id number
$bannedName = $_POST['bannedName']; // Name of person banned
$serverId = $_POST['server']; // Server ID

$lengthInSec = $length*3600; // Convert from hours to seconds
$now = time() + $lengthInSec;

// Make sure the user has the privileges
if($member || $admin || $banManager || $fullPower) {
  $allowedToBan = true;
}

if($allowedToBan) {

  // Members can add, but the ban does not take immediate affect (must be approved)
  // All others can ban and it will become active
  if($member) {
    $pending = 1;
  } else {
    $pending = 0;
  }
  
  if($config->enableSmfIntegration) {
    $username = $user_info['username'];
  } else {
    $username = $_SESSION['name'];
  }
  
  $banQueries = new BanQueries();
  $userQueries = new UserQueries();

  $user = $userQueries->getUserInfo($username);
  
  // Check to see if we are adding an IP ban
  if(isset($_POST['ipBan'])) {
    $banQueries->addIpBan($_POST['ip']);
  } else { // Otherwise we are adding a regular ban
  
    // Add the ban
    $banQueries->addBan($steamId, $length, $now, $reason, $username, $pending, $bannedName, $serverId, null, $user->getSteamId());

    kickUser($steamId, $serverId, $config);

    if($config->sendEmails) {
      // Email
      $subject = "Ban Added By Web App";

      $body = "<html><body>";
      $body .= "The following ban has been added by ";
      if($member) {
        $body .= "a Member and MUST be reviewed.";
      } else if($admin) {
        $body .= "an Admin.";
      } else if($banManager || $fullPower) {
        $body .= "a Ban Manager.";
      }
      $body .= "\n\n";

      // Use this to build the URL link (replace processWebBan with updateBan)
      $url = "http://".$_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
      str_replace("processWebBan", "updateBan", "$url");

      $body .= "\n\n";
      $body .= "Click on the following link to review the newly added ban: <a href='".$url."&banId=".$banId."'>New Ban</a>";
      $body .= "<p>".$bannedName." (".$steamId.") was banned from all servers.</p>";
      $body .= "</body></html>";

      $banManagerEmails = $config->banManagerEmails;
      for($i=0; $i<count($banManagerEmails); $i++) {

        // To send HTML mail, the Content-type header must be set
        $headers  = "MIME-Version: 1.0" . "\r\n";
        $headers .= "Content-type: text/html; charset=utf-8" . "\r\n";
        // Additional headers
        $headers .= "From: ".$config->siteName." Ban Management <".$config->emailFromHeader.">" . "\r\n";
        mail($banManagerEmails[$i], $subject, $body, $headers);
      }
      // Finish Email
    }
  }
}
header( 'Location: index.php?page=banlist' );

function kickUser($steamId, $serverId, $config) {

  $serverQueries = new ServerQueries();
  
  $server = $serverQueries->getServer($serverId);
  
  $r = new rcon($server->getIp(),$server->getPort(),$server->getRcon());
  $r->Auth();
  $banReason = "You are banned. Appeal at ".$config->appealSite;
  $r->rconCommand("kickid " . $steamId . " '" . $banReason . "'");
}
?>
